cd ~/Download/WOA

nc = netcdf('t00an1.nc','r');
x = nc{'lon'}(:);
y = nc{'lat'}(:);
z = nc{'depth'}(:);

d = abs((x - 335.5));
i = find(d == min(d));

T = nc{'t00an1'}(1,:,:,i);
T(T == nc{'t00an1'}.missing_value) = NaN;
T = squeeze(T)';

close(nc);

nc = netcdf('s00an1.nc','r');
S = nc{'s00an1'}(1,:,:,i);
S(S == nc{'s00an1'}.missing_value) = NaN;
S = squeeze(S)';

close(nc)

rho = T;

pcolor(y,-z,squeeze(T)');
rhoi = [0:2:30];

zi = zeros(size(T,2),length(rhoi));

for j=1:size(T,1)
  m = find(~isnan(rho(j,:)));
  if ~isempty(m)
    zi(j,:) = interp1(rho(j,m),z,rhoi);
  end
end

plot(y,-zi)

dzi = zi(:,2:end) - zi(:,1:end-1);


