dx = 1e3;
n = 101;
m = 2;

x = dx * [0:n-1]';

h = zeros(n,m);
u = zeros(n+1,m);
hu = zeros(n+1,m);



bottom = -50 * (erf(x-7) - 2 + 1.6 * exp(-(x-2.2).^2 / 1^2) + x/20) ;
bottom(:) = 150;

h(:,1) = 30 * exp(-x.^2 / 2^2) + bottom/3;
h(:,2) = 0 * exp(-x.^2 / 2^2) + 2*bottom/3;


dt = 0.00020;

rho = [1024 1024];

g = 9.81;
gp = (rho(2) - rho(1))/rho(1) * g;

max_dt = dx/sqrt(g*max(bottom))
dt = 0.7 * max_dt;

figure,

for i=0:1000

  hu(2:end-1,:) = (h(1:end-1,:)+h(2:end,:)) .* u(2:end-1,:)/2;

  h(:,1) = h(:,1) - dt * (hu(2:end,1) - hu(1:end-1,1))/dx;
  h(:,2) = h(:,2) - dt * (hu(2:end,2) - hu(1:end-1,2))/dx;

  p(:,1) = rho(1) * g * (h(:,1)+h(:,2) - bottom);
  p(:,2) = rho(1) * (g * h(:,1) + (g + gp) * (h(:,2) - bottom));

  u(2:end-1,1) = u(2:end-1,1) - dt * (p(2:end,1)-p(1:end-1,1))./(dx*rho(1)) ;
  u(2:end-1,2) = u(2:end-1,2) - dt * (p(2:end,2)-p(1:end-1,2))./(dx*rho(2)) ;
  

  if mod(i,5) == 0
    i
    clf
    hold on
    z(:,3) = -bottom;
    z(:,2) = z(:,3) + h(:,2);
    z(:,1) = z(:,2) + h(:,1);
    
    plot(x,z(:,1))
    plot(x,z(:,2))
    plot(x,z(:,3))
    axis([min(x) max(x) -max(bottom) 10]);
    drawnow
  end
end