load huv_20071127;

nc = netcdf('ssh_20071127.nc','c');


% define the dimension longitude and latitude of size
% 360 and 181 respectively.

nc('longitude') = length(lon);
nc('latitude') = length(lat);

% coordinate variable longitude

% create a variable longitude of type double with 
% 360 elements (dimension longitude).
nc{'longitude'} = ncdouble('longitude');              

% store the octave variable longitude in the netcdf file
nc{'longitude'}(:) = lon;                       

% define a string attribute of the variable longitude
nc{'longitude'}.units = 'degree West';                

% coordinate variable latitude

nc{'latitude'} = ncdouble('latitude');;                  
nc{'latitude'}(:) = lat;                         
nc{'latitude'}.units = 'degree North';                

% define variable ssh

% create a variable ssh of type double of the size 360x181 
% (dimension longitude and latitude).    

nc{'ssh'} = ncdouble('latitude','longitude');        

% store the octave variable ssh in the netcdf file
mv = 99999;
h = h/100;
h(isnan(h)) = mv;

nc{'ssh'}(:) = h;

nc{'ssh'}.missing_value = mv;                  
nc{'ssh'}.FillValue_ = mv;                  

% define a string attribute of the variable
nc{'ssh'}.units = 'm';                  

% define a vector of doubles attribute of the variable
nc{'ssh'}.long_name = 'absolute sea surface height';

% define a global string attribute
nc.history = 'netcdf file converted from huv_20071127.mat';

% close netcdf file and all changes are written to disk
close(nc)
