function [psif,nit,relerr,r]=inversepoisson(om,psistart,dx,dy,nmax,tol,optsur)
persistent D

[M,N] = size(om);

if isempty(D)
  disp('create laplacian');
  BC = sparse( N*M , N*M );

  if 1
    for j=2:N-1
      % compute the difference between (1,j) and (m-1,j)
      % which must be zero
      
      BC(sub2ind([M N],1,j),sub2ind([M N],1,j)) = 1;
      BC(sub2ind([M N],1,j),sub2ind([M N],M-1,j)) = -1;

      % compute the difference between (M,j) and (2,j)
      % which must be zero
      
      BC(sub2ind([M N],M,j),sub2ind([M N],M,j)) = 1;
      BC(sub2ind([M N],M,j),sub2ind([M N],2,j)) = -1;
    end

    for i=1:M
      % compute the difference between (i,1) and (i,n-1)
      % which must be zero
      
      BC(sub2ind([M N],i,1),sub2ind([M N],i,1)) = 1;
      BC(sub2ind([M N],i,1),sub2ind([M N],i,N-1)) = -1;

      % compute the difference between (i,n) and (i,2)
      % which must be zero
      
      BC(sub2ind([M N],i,N),sub2ind([M N],i,N)) = 1;
      BC(sub2ind([M N],i,N),sub2ind([M N],i,2)) = -1;
    end

    BC(sub2ind([M N],1,1),sub2ind([M N],1,1)) = 1;

  else
    for j=2:N-1
      % values (1,j)

      BC(sub2ind([M N],1,j),sub2ind([M N],1,j)) = 1;

      % values (M,j)
      
      BC(sub2ind([M N],M,j),sub2ind([M N],M,j)) = 1;
    end

    for i=1:M
      % values (i,1)
      
      BC(sub2ind([M N],i,1),sub2ind([M N],i,1)) = 1;

      % values (i,n)
      
      BC(sub2ind([M N],i,N),sub2ind([M N],i,N)) = 1;
    end
  end
  
  Lap = divand_laplacian(ones(M,N),{ones(M,N)/dx,ones(M,N)/dy});
  D = Lap + BC;
end

if 0
  [LB, q, PB] = splchol (D);
%  [LB,p] = chol(D);
  PB = speye(size(D)); 
  LB=LB';

  
tmp2 = PB * (LB' \ (LB \ (PB' * om(:)))) ;
maxdiff(tmp,tmp2)
end

tmp = D \ om(:);

psif = reshape(tmp,[M N]);
nit = 0;

%psif = psif - psif(1,1);
%psif = psif - mean(psif(:));

residual = D * psif(:) - om(:);
relerr = 0;
r = 0;

if 0
%
val=size(om);
M=val(1);
N=val(2);
psi=psistart;
psin=psi;
r=zeros(M,N);
psi3=zeros(M,N);


% Adapt stopping criteria
n=0;
relerr=1;
err=zeros(M,N);
while n < nmax && relerr > tol
  n=n+1;

  if 0
  i=2:M-1;
  j=2:N-1;

  dx2=(psi(i+1,j)+psi(i-1,j)-2*psi(i,j))/(dx*dx);
  dy2=(psi(i,j+1)+psi(i,j-1)-2*psi(i,j))/(dy*dy);
  err(i,j)=(om(i,j)-(dx2+dy2))/(2/(dx.*dx)+2/(dy*dy));
  %psin(i,j)=psi(i,j)-optsur*err(i,j);
  psi(i,j)=psi(i,j)-optsur*err(i,j);

  errtot=sum(sum(err(i,j).^2))
  psitot=sum(sum(psi(i,j).^2));
  avrpsi=sum(sum(psi(i,j)));
  end
        for i=2:M-1
        for j=2:N-1
            dx2=(psi(i+1,j)+psi(i-1,j)-2*psi(i,j))/(dx*dx);
            dy2=(psi(i,j+1)+psi(i,j-1)-2*psi(i,j))/(dy*dy);
            err(i,j)=(om(i,j)-(dx2+dy2))/(2/(dx*dx)+2/(dy*dy));

            psi(i,j)=psi(i,j)-optsur*err(i,j);
        end
    end

  i=2:M-1;
  j=2:N-1;

  errtot=sum(sum(err(i,j).^2))
  psitot=sum(sum(psi(i,j).^2));
  avrpsi=sum(sum(psi(i,j)));
  
  % psin(:,1)=0;
  % psin(:,N)=0;
  errtot=errtot/(N-2)/(M-2);
  psitot=psitot/(N-2)/(M-2)-(avrpsi/(N-2)/(M-2))^2;
  relerr=sqrt(errtot/psitot);
  %psin(2,2)=0;
  psi=periodic(psi);
  %psi=psin;
  psi(:,1)=0;
  psi(:,N)=0;
  % keep initial value of psi
  psi(:,1)=psistart(:,1);
  psi(:,N)=psistart(:,N);
  %psi(1,:)=0;
  %psi(M,:)=0;
  %     subplot(2,1,1)
  % pcolor(err');
  % colorbar
  %     subplot(2,1,2)
  % pcolor(psi');
  % colorbar
  % 
  % pause(0.01);
  avrpsi=avrpsi/(N-2)/(M-2);
  %psi=psi-avrpsi;

  x=psi(2,10);
  y=psi(3,10)-x;
end
%psin=psi;
nit=n;
psif=psi;
r=periodic(err);

end