figdir = '/home/abarth/Lectures/OCEA0036-1/Notes/Fig/Movie_sigma';



dx = 0.1;
n = 101;

x = dx * [0:n-1]';

zeta = zeros(n,1);
U = zeros(n+1,1);

zeta(1) = 0.1;
zeta = 20*exp(-x.^2 / 2^2);
xf = x;
hf = -50 * (erf(xf-7) - 2 + 1.6 * exp(-(xf-2.2).^2 / 1^2) + xf/20) ;
%h(:) = 150;

h_u = (hf(1:end-1)+hf(2:end))/2;
dt = 0.00020;
g = 9.81;

max_dt = dx/sqrt(g*max(hf))

% sigma

hmin = 50;

N = 10;
sigma = linspace(0,1,N);

[sc_r,cs_r,sc_w,cs_w] = my_scoord(N,3,0.01);
Z = squeeze(makez(hf,hmin,sc_r,cs_r));

sigma = cs_w;

I = 1:10:length(xf);
x = xf(I)';
h = hf(I)';

X = repmat(x',[1 N+1]);

%mov = moviefile([figdir '/movie_sigma.gif']);           

set(gcf,'PaperPosition',[0 0 400 400]);

for i=0:50*200
%for i=0:5
  zeta = zeta - dt * (U(2:end,1) - U(1:end-1,1))/dx;
  U(2:end-1) = U(2:end-1) - dt * g * h_u .* (zeta(2:end)-zeta(1:end-1))./dx ;

  zetac = zeta(I)';

  if mod(i,50) == 0
    i
    clf
    hold on
    %plot(xf,zeta)

    Z = (h + zetac)' * sigma + repmat(zetac',[1 N+1]);
    
    plot(X(:,1:end-1),Z(:,1:end-1),'b')
    plot(X',Z','b')

    patch([x x(end) x(1)],-[h max(h) max(h)],0.4 * [1 1 1])
    plot(xf,zeta,'linewidth',2,'color',[.2 .9 .2])
    ylim([-max(h) 25]);
    xlim([xf(1) xf(end)]);
    title('sigma coordinate and surf. gravity. wave');
    %  drawnow
    
    if i==50*40      
       print('-depsc',sprintf('%s/%06d.eps',figdir,i/50));
    end    

    print('-dpng',sprintf('%s/%06d.png',figdir,i/50));
  end
  
end


