figdir = '/home/abarth/Lectures/OCEA0036-1/Notes/Fig/';

xf = 0:0.1:10;

zetaf = 0*xf;
hf = 50 * (erf(xf-7) - 2 + 1.6 * exp(-(xf-2.2).^2 / 1^2) + xf/20) ;
hmin = 50;

N = 10;
sigma = linspace(0,1,N);

[sc_r,cs_r,sc_w,cs_w] = my_scoord(N,3,0.01);
Z = squeeze(makez(hf,hmin,sc_r,cs_r));

sigma = -cs_w;

I = 1:10:length(xf);
x = xf(I);
h = hf(I);

X = repmat(x',[1 N+1]);


subplot(1,2,1);

hold on
z = min(h) * ones(1,length(h))' * sigma;


for j=1:length(sigma)-1
  for i=1:length(x)-1
    if   z(i,j)+z(i,j+1)+z(i+1,j)+z(i+1,j+1) < 2*(h(i)+h(i+1))
      hp=patch(x(i+[0 1 1 0]),[z(i+[0 1],j)' z(i+[1 0],j+1)'],0.4 * [1 1 1]);
      set(hp,'linestyle','none');
    end
  end
end

for i=1:length(x)
  plot([x(i) x(i)],[z(i,1) z(i,end)],'b');
end
plot(x,z,'b')

plot(xf,hf,'k','linewidth',2)
ylim([-150 10]);
title('z');


subplot(1,2,2);

z = h' * sigma;

hold on

plot(X',z','b')
plot(X,z,'b')

patch([x x(end) x(1)],[h min(h) min(h)],0.4 * [1 1 1])
plot(xf,hf,'k','linewidth',2)
ylim([-150 10]);
title('sigma');


set(gcf,'PaperPosition',[0 0 500 300]);
print('-deps',[figdir '/sigma_coord.eps']);



