figdir = '/home/abarth/Lectures/OCEA0036-1/Notes/Fig/';

if ~exist('h','var')
  nc = netcdf('etopo5.nc','r');

  h = nc{'topo'}(:)';
  lon = nc{'topo_lon'}(:);
  lat = nc{'topo_lat'}(:);

  close(nc);
  
  lat = lat(2:end);
  h = h(:,2:end);
  lon = mod(lon+360,360);
end

r = 12;
%r = 3;
imax = length(lon)/r;
jmax = length(lat)/r;



hc = squeeze(mean(mean(reshape(h,[r imax r jmax]),1),3));
lonc = squeeze(mean(reshape(lon,[r imax]),1));
latc = squeeze(mean(reshape(lat,[r jmax]),1));

% close the globe

lonc = [lonc lonc(1)+360];
hc = [hc; hc(1,:)];


phi = lonc*pi/180;
theta = (90 - latc)*pi/180;


[phi,theta] = ndgrid(phi,theta);

% cartesian coordinates

hc = -hc;

r = ones(size(hc)) ;
%r = r  - hc/1e5 ;



x = r .* sin(theta) .* cos(phi);
y = r .* sin(theta) .* sin(phi);
z = r .* cos(theta);

hc(hc < 0) = -100;
%hc(hc < 0) = NaN;
%hc(0 < hc & hc < 100) = 100;

map = [0.7 0.7 0.7; colormap];
colormap(map)

surf(x,y,z,hc)
%caxis([0 max(hc(:))]);
colorbar('v')
axis off

angle = .5;  set(gca,'CameraPosition',20*[cos(angle) -sin(angle) .7]);

if 1
i = 1:10:size(x,1);
j = [1:10:size(x,2) size(x,2)];

hold on
a = 1.01;
plot3(a*x(i,j),a*y(i,j),a*z(i,j))
plot3(a*x(i,j)',a*y(i,j)',a*z(i,j)')
end

set(gca,'CameraViewAngle',6)

if 0
for angle=0:0.1:2*pi
  set(gca,'CameraPosition',20*[cos(angle) -sin(angle) .5]);
  drawnow
end
end


%print('-deps',[figdir '/spherical_mesh.eps']);
print('-dpng',[figdir '/rot_spherical_mesh.png']);
